/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.ExcepcionRedondo;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderExcepcionRedondo;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;

/**
 *
 * @author Administrador
 */
@Controller("busquedaExceptionRedondoController")
@Scope("prototype")
public class BusquedaExcepcionRedondoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ExcepcionRedondo> plwExcepcionRedondo;
    @Autowired
    private ParadaService paradaService;
    private Combobox cmbOrigem;
    private Combobox cmbDestino;
    private String txtIndtipo = "";
    private MyListbox excepcionRedondoList;
    private Paging pagingExcepcionRedondo;
    private Radio radioA;
    private Radio radioC;

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verExceptionRedondo(new ExcepcionRedondo());
    }

    public Radio getRadioA() {
        return radioA;
    }

    public void setRadioA(Radio radioA) {
        this.radioA = radioA;
    }

    public Radio getRadioC() {
        return radioC;
    }

    public void setRadioC(Radio radioC) {
        this.radioC = radioC;
    }

    public String getTxtIndtipo() {
        return txtIndtipo;
    }

    public void setTxtIndtipo(String txtIndtipo) {
        this.txtIndtipo = txtIndtipo;
    }
   

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        excepcionRedondoList.setItemRenderer(new RenderExcepcionRedondo());
        excepcionRedondoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ExcepcionRedondo mc = (ExcepcionRedondo) excepcionRedondoList.getSelected();
                verExceptionRedondo(mc);
            }
        });

        refreshLista();

        radioA.setChecked(true);
        txtIndtipo = "A";
    }

    private void verExceptionRedondo(ExcepcionRedondo er) {
        if (er == null) {
            return;
        }

        Map args = new HashMap();
        args.put("excepcionRedondo", er);
        args.put("excepcionRedondoList", excepcionRedondoList);

        openWindow("/gui/tarifas/editarExceptionRedondo.zul",
                Labels.getLabel("editarExceptionRedondoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ExcepcionRedondo> excepcionRedondoBusqueda =
                new HibernateSearchObject<ExcepcionRedondo>(ExcepcionRedondo.class, pagingExcepcionRedondo.getPageSize());
        excepcionRedondoBusqueda.addFilterEqual("activo", Boolean.TRUE);

        Parada origem = (Parada) (cmbOrigem.getSelectedItem() != null ? cmbOrigem.getSelectedItem().getValue() : null);
        Parada destino = (Parada) (cmbDestino.getSelectedItem() != null ? cmbDestino.getSelectedItem().getValue() : null);

        excepcionRedondoBusqueda.addFilterEqual("origem", origem);
        excepcionRedondoBusqueda.addFilterEqual("destino", destino);

        String indTipo = txtIndtipo;
        if (indTipo.isEmpty()) {
            excepcionRedondoBusqueda.addFilterEqual("indtipo", null);
        } else {
            excepcionRedondoBusqueda.addFilterEqual("indtipo", indTipo);
        }

        excepcionRedondoBusqueda.addSortAsc("indtipo");
        plwExcepcionRedondo.init(excepcionRedondoBusqueda, excepcionRedondoList, pagingExcepcionRedondo);

        if (excepcionRedondoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaExceptionRedondoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$radioA(Event ev) {
        txtIndtipo = "A";
    }

    public void onClick$radioC(Event ev) {
        txtIndtipo = "C";
    }
}
